/*
 * optionsDialog.js
 * Copyright  2007, 2008 Tommi Rautava
 * 
 * This file is part of Popomungo.
 *
 * Popomungo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Popomungo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

var pm_OptionsDialog = {
	
	treeView: null,
	
	userOptionsPaneIsLoaded: false,
	
	onLoad: function onLoad() {
		pm_Logger.setTraceLevelFromPref();
		
		pm_Logger.debug("pm_OptionsDialog onLoad event");

		return true;
	},
	
	onDialogAccept: function onDialogAccept() {
		try {
			pm_Logger.debug("onDialogAccept event");

			// Store the current character options.
			if (this.userOptionsPaneIsLoaded) {
				this.userOptionsApply();
			}
		}
		catch (err) {
			pm_Logger.logError(err);
		}
		
		return true;
	},
	
	interactionFeaturesOnCommand: 
	function interactionFeaturesOnCommand() {
		var disabled = !document.getElementById('interaction.features.checkbox').checked;
		
		pm_Logger.debug("Interaction features disabled="+ disabled);

		document.getElementById('interaction.option.4.label').disabled = disabled;
		document.getElementById('interaction.option.4.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.4.highlight.checkbox').disabled = disabled;
		
		document.getElementById('interaction.option.9.label').disabled = disabled;
		document.getElementById('interaction.option.9.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.9.highlight.checkbox').disabled = disabled;

		document.getElementById('interaction.option.10.label').disabled = disabled;
		document.getElementById('interaction.option.10.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.10.highlight.checkbox').disabled = disabled;

		document.getElementById('interaction.option.11.label').disabled = disabled;
		document.getElementById('interaction.option.11.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.11.highlight.checkbox').disabled = disabled;

		document.getElementById('interaction.option.13.label').disabled = disabled;
		document.getElementById('interaction.option.13.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.13.highlight.checkbox').disabled = disabled;

		document.getElementById('interaction.option.15.label').disabled = disabled;
		document.getElementById('interaction.option.15.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.15.highlight.checkbox').disabled = disabled;

		document.getElementById('interaction.option.16.label').disabled = disabled;
		document.getElementById('interaction.option.16.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.16.highlight.checkbox').disabled = disabled;

		document.getElementById('interaction.option.21.label').disabled = disabled;
		document.getElementById('interaction.option.21.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.21.highlight.checkbox').disabled = disabled;
		
		document.getElementById('interaction.option.28.label').disabled = disabled;
		document.getElementById('interaction.option.28.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.28.highlight.checkbox').disabled = disabled;
		
		document.getElementById('interaction.option.29.label').disabled = disabled;
		document.getElementById('interaction.option.29.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.29.highlight.checkbox').disabled = disabled;
		
		document.getElementById('interaction.option.31.label').disabled = disabled;
		document.getElementById('interaction.option.31.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.31.highlight.checkbox').disabled = disabled;
		
		document.getElementById('interaction.option.33.label').disabled = disabled;
		document.getElementById('interaction.option.33.command.radiogroup').disabled = disabled;
		document.getElementById('interaction.option.33.highlight.checkbox').disabled = disabled;
		
		return true;
	},
	
	performanceFeaturesOnCommand: 
	function performanceFeaturesOnCommand() {
		var disabled = !document.getElementById('performances.features.checkbox').checked;
		
		pm_Logger.debug("Performance features disabled="+ disabled);
		document.getElementById('performances.reverseTicketLimits.enabled').disabled = disabled;
		document.getElementById('performances.showNumberOfSoldTicketsPerShow.enabled.pref').disabled = disabled;
		document.getElementById('performances.showSoldTicketsInCompactFormat.enabled.pref').disabled = disabled;
		document.getElementById('performances.showTotalNumberOfSoldTickets.enabled.pref').disabled = disabled;
		document.getElementById('performances.ticketSalesEstimates.enabled').disabled = disabled;
		document.getElementById('performances.showTotalNumberOfShows.enabled.pref').disabled = disabled;
		document.getElementById('performances.showTotalIncome.enabled.pref').disabled = disabled;
		document.getElementById('performances.ticketSalesStatistics.enabled').disabled = disabled;
		document.getElementById('progressBars.shows.addSoldTicketsProgressBar.pref').disabled = disabled;
		document.getElementById('performances.showIncomePerShow.enabled.pref').disabled = disabled;
		document.getElementById('performances.useColorsOnUpcomingShows.enabled.pref').disabled = disabled;

		return true;
	},

	scoringFeaturesOnCommand: 
	function scoringFeaturesOnCommand() {
		var disabled = !document.getElementById('scoring.features.checkbox').checked;
		
		pm_Logger.debug("Scoring features disabled="+ disabled);
		document.getElementById('scoring.addScoreNumber.enabled.pref').disabled = disabled;
		document.getElementById('scoring.scoreBase.pref').disabled = disabled;
		document.getElementById('scoring.compareAttributes.enabled.pref').disabled = disabled;
		document.getElementById('scoring.colorNumber.colorType.pref').disabled = disabled;

		this.addScoreNumbersCheckboxOnCommand();
		this.addComparisonScoreNumbersCheckboxOnCommand();
		this.colorTypeOnCommand();

		return true;
	},
	
	addScoreNumbersCheckboxOnCommand:
	function addScoreNumbersCheckboxOnCommand() {
		var cb = document.getElementById('scoring.addScoreNumber.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('scoring.colorNumber.enabled.pref').disabled = disabled;
		document.getElementById('scoring.disableLink.enabled.pref').disabled = disabled;
		
		return true;
	},

	addComparisonScoreNumbersCheckboxOnCommand:
	function addComparisonScoreNumbersCheckboxOnCommand() {
		var cb = document.getElementById('scoring.compareAttributes.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('scoring.compareAttributes.numberPosition.pref').disabled = disabled;
		
		return true;
	},
	
	colorTypeOnCommand: function colorTypeOnCommand() {
		pm_Logger.debug("colorTypeOnCommand()");
		var rg = document.getElementById('scoring.colorNumber.colorType.radiogroup');
		var disabled = (rg.value != 1) || rg.disabled;
		
		document.getElementById('scoring.colorNumber.gradientColor.from.colorpicker').disabled = disabled;
		document.getElementById('scoring.colorNumber.gradientColor.from.colorpicker.label').disabled = disabled;
		document.getElementById('scoring.colorNumber.gradientColor.to.colorpicker').disabled = disabled;
		document.getElementById('scoring.colorNumber.gradientColor.to.colorpicker.label').disabled = disabled;
		
		return true;
	},

	progressBarsFeaturesOnCommand:
	function progressBarsFeaturesOnCommand() {
		var disabled = !document.getElementById('progressBars.features.enabled.checkbox').checked;
		
		pm_Logger.debug("Progress bars features disabled="+ disabled);
		document.getElementById('progressBars.shows.addSoldTicketsCount.checkbox').disabled = disabled;
		document.getElementById('progressBars.shows.addSoldTicketsPercentage.checkbox').disabled = disabled;
		document.getElementById('progressBars.font.size.radiogroup').disabled = disabled;
		document.getElementById('progressBars.font.weight.radiogroup').disabled = disabled;
		document.getElementById('progressBars.showProgressBarValues.pref').disabled = disabled;
		document.getElementById('progressBars.shows.addSoldTicketsProgressBar.pref').disabled = disabled;

		return true;
	},

	highlightingFeaturesOnCommand:
	function highlightingFeaturesOnCommand() {
		var disabled = !document.getElementById('highlighting.features.enabled.checkbox').checked;
		
		pm_Logger.debug("Highlighting features disabled="+ disabled);
		document.getElementById('highlighting.highlightCeoLocale.enabled.pref').disabled = disabled;
		document.getElementById('competitions.colorizeCompetitionEntries.enabled.pref').disabled = disabled;
		document.getElementById('highlighting.peopleAtSameTown.enabled.pref').disabled = disabled;
		document.getElementById('highlighting.highlightLowStock.enabled.pref').disabled = disabled;
		document.getElementById('highlighting.highlightHighTicketPrice.enabled.pref').disabled = disabled;
		document.getElementById('highlighting.highlightLowTicketLimit.enabled.pref').disabled = disabled;		

		this.highlightingLowStockEnabledCheckboxOnCommand();
		this.highlightingHighTicketPriceCheckboxOnCommand();
		this.highlightingLowTicketLimitsCheckboxOnCommand();

		return true;
	},

	highlightingLowStockEnabledCheckboxOnCommand:
	function highlightingLowStockEnabledCheckboxOnCommand() {
		var cb = document.getElementById('highlighting.highlightLowStock.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('products.lowStock.alertLevel.pref').disabled = disabled;
		document.getElementById('products.lowStock.alertLevel.textbox.label').disabled = disabled;

		document.getElementById('products.lowStock.warningLevel.pref').disabled = disabled;
		document.getElementById('products.lowStock.warningLevel.textbox.label').disabled = disabled;
		
		return true;
	},

	highlightingHighTicketPriceCheckboxOnCommand:
	function highlightingHighTicketPriceCheckboxOnCommand() {
		var cb = document.getElementById('highlighting.highlightHighTicketPrice.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('tickets.highPrice.alertLevel.pref').disabled = disabled;
		document.getElementById('tickets.highPrice.alertLevel.textbox.label').disabled = disabled;

		document.getElementById('tickets.highPrice.warningLevel.pref').disabled = disabled;
		document.getElementById('tickets.highPrice.warningLevel.textbox.label').disabled = disabled;
		
		return true;
	},

	highlightingLowTicketLimitsCheckboxOnCommand:
	function highlightingLowTicketLimitsCheckboxOnCommand() {
		var cb = document.getElementById('highlighting.highlightLowTicketLimit.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('ticketLimits.lowTicketLimit.soldOutInDays.label').disabled = disabled;
		document.getElementById('ticketLimits.lowTicketLimit.percentage.label').disabled = disabled;

		document.getElementById('ticketLimits.soldOutInDays.warningLevel.textbox.label').disabled = disabled;
		document.getElementById('ticketLimits.lowTicketLimit.soldOutInDays.warningLevel.pref').disabled = disabled;
		document.getElementById('ticketLimits.lowTicketLimit.percentage.warningLevel.pref').disabled = disabled;
		
		document.getElementById('ticketLimits.soldOutInDays.alertLevel.textbox.label').disabled = disabled;
		document.getElementById('ticketLimits.lowTicketLimit.soldOutInDays.alertLevel.pref').disabled = disabled;
		document.getElementById('ticketLimits.lowTicketLimit.percentage.alertLevel.pref').disabled = disabled;

		return true;
	},

	linksFeaturesOnCommand:
	function linksFeaturesOnCommand() {
		var disabled = !document.getElementById('links.features.enabled.checkbox').checked;
		
		pm_Logger.debug("Links features disabled="+ disabled);
		document.getElementById('links.popup.enabled.checkbox').disabled = disabled;
		document.getElementById('links.visible.enabled.checkbox').disabled = disabled;

		this.popupLinksFeaturesOnCommand();
		this.visibleLinksFeaturesOnCommand();

		return true;
	},

	popupLinksFeaturesOnCommand:
	function popupLinksFeaturesOnCommand() {
		var cb = document.getElementById('links.popup.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('links.popup.character.enabled.checkbox').disabled = disabled;
		document.getElementById('links.popup.locale.enabled.checkbox').disabled = disabled;

		this.characterPopupLinksFeaturesOnCommand();
		this.localePopupLinksFeaturesOnCommand();
		
		return true;
	},

	characterPopupLinksFeaturesOnCommand:
	function characterPopupLinksFeaturesOnCommand() {
		var cb = document.getElementById('links.popup.character.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('links.popup.character.call.enabled.checkbox').disabled = disabled;
		document.getElementById('links.popup.character.sendMessage.enabled.checkbox').disabled = disabled;
		
		return true;
	},

	localePopupLinksFeaturesOnCommand:
	function localePopupLinksFeaturesOnCommand() {
		var cb = document.getElementById('links.popup.locale.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('links.popup.locale.moveHere.enabled.checkbox').disabled = disabled;
		
		return true;
	},

	visibleLinksFeaturesOnCommand:
	function visibleLinksFeaturesOnCommand() {
		var cb = document.getElementById('links.visible.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('links.visible.character.enabled.checkbox').disabled = disabled;
		document.getElementById('links.visible.locale.enabled.checkbox').disabled = disabled;
		document.getElementById('links.visible.type.radiogroup').disabled = disabled;

		this.visibleLinksTypeOnCommand();
		this.characterVisibleLinksFeaturesOnCommand();
		this.localeVisibleLinksFeaturesOnCommand();
		
		return true;
	},

	visibleLinksTypeOnCommand:
	function visibleLinksTypeOnCommand() {
		pm_Logger.debug("visibleLinksTypeOnCommand()");
		var rg = document.getElementById('links.visible.type.radiogroup');
		var disabled = (rg.value != 1) || rg.disabled;
		
		document.getElementById('links.visible.type.textColor.colorpicker').disabled = disabled;
		document.getElementById('links.visible.type.textColor.colorpicker.label').disabled = disabled;
		document.getElementById('links.visible.type.backgroundColor.colorpicker').disabled = disabled;
		document.getElementById('links.visible.type.backgroundColor.colorpicker.label').disabled = disabled;
		
		return true;
	},

	characterVisibleLinksFeaturesOnCommand:
	function characterVisibleLinksFeaturesOnCommand() {
		var cb = document.getElementById('links.visible.character.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('links.visible.character.call.enabled.checkbox').disabled = disabled;
		document.getElementById('links.visible.character.sendMessage.enabled.checkbox').disabled = disabled;
		
		return true;
	},

	localeVisibleLinksFeaturesOnCommand:
	function localeVisibleLinksFeaturesOnCommand() {
		var cb = document.getElementById('links.visible.locale.enabled.checkbox');
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById('links.visible.locale.moveHere.enabled.checkbox').disabled = disabled;
		
		return true;
	},
	
	
	travelingOnPaneLoad:
	function travelingOnPaneLoad() {
		this.travelingFeaturesOnCommand();

		this.localeIconsOnLoad();
		this.localeIconFeaturesOnCommand();
	},
	
	
	travelingFeaturesOnCommand:
	function travelingFeaturesOnCommand() {
		var disabled = !document.getElementById('traveling.features.enabled.checkbox').checked;
		
		pm_Logger.debug("Traveling features disabled="+ disabled);
		document.getElementById('traveling.addLocalizedRouteName.pref').disabled = disabled;
		document.getElementById('traveling.addTravelTimes.pref').disabled = disabled;
		document.getElementById('traveling.autoSelectTransportStartCity.pref').disabled = disabled;
		document.getElementById('traveling.autoSelectTransportStartTime.pref').disabled = disabled;
		
		return true;
	},


	localeIconsOnLoad:
	function localeIconsOnLoad() {
		try {
			pm_Logger.debug("Locale icons");
			
			var bundle = document.getElementById('popomungo.locale.locales.stringbundle');
	
			var children = pm_Prefs.getChildList(pm_PrefKeys.LOCALES_IMAGE_BASE);
			children.sort(function (a, b) { 
				return (parseInt(a) - parseInt(b));
			});
	
			pm_Logger.debug("children="+ children.length);
			
			this.treeView = new pm_LocaleIconsTreeView;
			
			for (var i = 0; i < children.length; i++) {
				var prefName = pm_PrefKeys.LOCALES_IMAGE_BASE + children[i];
				var url = pm_Prefs.getSetting(prefName, "");
				
				var matchResult = prefName.match(/\.(\d+)\./);
				var localeTypeId = matchResult[1];
				var localeTypeName = bundle.getString("locale."+ localeTypeId);
				
				var row = new pm_LocaleIconsTreeItem(localeTypeId, localeTypeName, url);
				this.treeView.appendItem(row);
			}
			
			var tree = document.getElementById("locales.localeIcon.tree");
			tree.view = this.treeView;
		}
		catch (err) {
			pm_Logger.logError(err);
		}
		
		return true;
	},
	
	
	localeIconFeaturesOnCommand:
	function localeIconFeaturesOnCommand() {
		var cb = document.getElementById("locales.icons.enabled.checkbox");
		var disabled = !cb.checked || cb.disabled;
		
		document.getElementById("locales.localeIcon.tree").disabled = disabled;
		
		this.localeIconSelectionChanged();
		
		return true;
	},
	

    localeIconSelectionChanged: 
    function localeIconSelectionChanged() {
		var cb = document.getElementById("locales.icons.enabled.checkbox");
		var disabled = !cb.checked || cb.disabled;

		var localeTypeNameTextbox = document.getElementById("localeTypeName.textbox");
    	var iconUrlTextbox = document.getElementById("localeIconUrl.textbox");
    	var localeIconUrlSetButton = document.getElementById("localeIconUrl.set.button");
    	var localeIconUrlResetButton = document.getElementById("localeIconUrl.reset.button");

		var setEnabled = false;
		var resetEnabled = false;

    	if (this.treeView.selection) {
	    	var row = this.treeView.selection.currentIndex;
	    	
	    	if (row >= 0) {
		    	var item = this.treeView.getItemAtIndex(row);
		    	
		    	if (item) {
			    	localeTypeNameTextbox.value = item.localeTypeName;
			    	iconUrlTextbox.value = item.localeIconUrl;
			    	setEnabled = true;
	
			    	var prefName = pm_PrefKeys.GetLocaleIconUrlPrefKey(item.localeTypeId);
			    	resetEnabled = pm_Prefs.prefHasUserValue(prefName);    	
		    	}
	    	}
    	}

		localeTypeNameTextbox.disabled = disabled || !setEnabled;
    	iconUrlTextbox.disabled = disabled || !setEnabled;
		localeIconUrlSetButton.disabled = disabled || !setEnabled;;
    	localeIconUrlResetButton.disabled = disabled || !resetEnabled;
    },


	resetLocaleIconsTree: function resetLocaleIconsTree() {
    	var tb;

    	tb = document.getElementById("localeTypeName.textbox");
    	tb.value = "";
    	tb.disabled = true;

    	tb = document.getElementById("localeIconUrl.textbox");
    	tb.value = "";
    	tb.disabled = true;

    	document.getElementById("localeIconUrl.set.button").disabled = true;
    	document.getElementById("localeIconUrl.reset.button").disabled = true;

		var tree = document.getElementById("locales.localeIcon.tree");
		tree.view = this.treeView;
	},
	
	
	setIconUrl: function setIconUrl() {
    	var row = this.treeView.selection.currentIndex;
    	var item = this.treeView.getItemAtIndex(row);

    	var localeIconUrlTextbox = document.getElementById("localeIconUrl.textbox");
    	var iconUrl = localeIconUrlTextbox.value;
    	pm_Logger.debug(item.localeTypeId +":"+ iconUrl);
    	item.localeIconUrl = iconUrl;
    	
    	// Save pref.
    	var prefName = pm_PrefKeys.GetLocaleIconUrlPrefKey(item.localeTypeId);
    	pm_Prefs.setPref(prefName, iconUrl.toString());

		pm_OptionsDialog.resetLocaleIconsTree();
	},	
	

	resetIconUrl: function resetIconUrl() {
    	var row = this.treeView.selection.currentIndex;
    	var item = this.treeView.getItemAtIndex(row);
	    
	    // Reset pref.	
    	var prefName = pm_PrefKeys.GetLocaleIconUrlPrefKey(item.localeTypeId);
    	pm_Prefs.clearUserPref(prefName);

	    item.localeIconUrl = pm_Prefs.getPref(prefName, "");

		pm_OptionsDialog.resetLocaleIconsTree();
	},	
	

	userOptionsOnPaneLoad: function userOptionsOnPaneLoad() {
		this.userOptionsPaneIsLoaded = true;
		
		try {
			var charList = pm_UserSettings.GetCharacterIdList();
			var listBox = document.getElementById("userOptions.character.list");
			
			pm_Logger.debug("characters="+ charList.length);
			
			if (charList.length > 0) {
				for (var i = 0; i < charList.length; i++) {
					var charId = charList[i];
					var charName = pm_Prefs.getCharacterPref(charId, pm_PrefKeys.CHARACTER_NAME, "");
					
					pm_Logger.debug(charId +": "+ charName);
					
					listBox.appendItem(charName +" ("+ charId +")", charId);
				}
				
				var currentCharacter = pm_Prefs.getPref(pm_PrefKeys.CURRENT_CHARACTER, charList[0]) || charList[0];
				listBox.value = currentCharacter;
			}
			else {
				listBox.appendItem("");				
			}

			this.userOptionsCharacterChanged();
		}
		catch (err) {
			pm_Logger.logError(err);
		}

		return true;
	},
	
	
	userOptionsEnableApply: function userOptionsEnableApply(enable) {
		document.getElementById("userOptions.apply.button").disabled = !enable;
		
		return true;
	},


	userOptionsApply: function userOptionsApply() {
		try {
			var listBox = document.getElementById("userOptions.character.list");
			pm_Logger.debug("listBox.value: "+ listBox.value);
			
			var charId = parseInt(listBox.value) || 0;
	
			if (charId) {
				pm_Prefs.setPref(pm_PrefKeys.CURRENT_CHARACTER, charId);
	
				var languageId = parseInt(document.getElementById("userOptions.language.list").value);
				var dateFormat = parseInt(document.getElementById("userOptions.dateFormat.radiogroup").value);
				var timeFormat = parseInt(document.getElementById("userOptions.timeFormat.radiogroup").value);
				var cityName = document.getElementById("userOptions.city.textbox").value;
	
				pm_Prefs.setCharacterPref(charId, 
					pm_PrefKeys.LANGUAGE_ID, 
					languageId);
	
				pm_Prefs.setCharacterPref(charId, 
					pm_PrefKeys.DATE_FORMAT_TYPE_ID, 
					dateFormat);
	
				pm_Prefs.setCharacterPref(charId, 
					pm_PrefKeys.TIME_FORMAT_TYPE_ID, 
					timeFormat);
				
				pm_Prefs.setCharacterPref(charId, 
					pm_PrefKeys.CITY_NAME, 
					cityName);				
			}
			
			this.userOptionsEnableApply(false);
		}
		catch (err) {
			pm_Logger.logError(err);
		}
		
		return true;
	},
	
	
	userOptionsDelete: function userOptionsDelete() {
		try {
			var charId = parseInt(document.getElementById("userOptions.character.list").value || 0);
			var confirmationLabel = document.getElementById("userOptions.delete.confirmation.label");
			
			if (charId) {
				// Confirm deletion.
				if (confirm(confirmationLabel.value)) {
					// Delete prefs
					var prefBranch = pm_PrefKeys.CHARACTERS_BASE + charId + ".";
					pm_Logger.debug("Deleting preference branch "+ prefBranch)
					pm_Prefs.deleteBranch(prefBranch);
					
					var currentCharacter = pm_Prefs.getPref(pm_PrefKeys.CURRENT_CHARACTER, 0) || 0;
					
					// Reset the current character info, if the options are deleted.
					if (currentCharacter == charId) {
						pm_Logger.debug("Clearing preference "+ pm_PrefKeys.CURRENT_CHARACTER);
						pm_Prefs.clearUserPref(pm_PrefKeys.CURRENT_CHARACTER);
					}
	
					// Reload list items.
					var listBox = document.getElementById("userOptions.character.list");
					listBox.removeAllItems();
					listBox.value = "";
					this.userOptionsOnPaneLoad();
				}
			}
		}
		catch (err) {
			pm_Logger.logError(err);
		}
		
		return true;
	},
	
	
	userOptionsEnableAll: function userOptionsEnableAll(enable) {
		try {
			var disable = !enable;
			
			document.getElementById("autoDetectCityName.enabled.pref").disabled = disable;
			document.getElementById("autoDetectDateAndTimeFormat.enabled.pref").disabled = disable;
			document.getElementById("autoDetectLanguage.enabled.pref").disabled = disable;
	
			document.getElementById("userOptions.character.list").disabled = disable;
			document.getElementById("userOptions.delete.button").disabled = disable;
	
			document.getElementById("userOptions.language.list").disabled = disable;
			document.getElementById("userOptions.dateFormat.radiogroup").disabled = disable;
			document.getElementById("userOptions.timeFormat.radiogroup").disabled = disable;
			document.getElementById("userOptions.city.textbox").disabled = disable;
			
			//document.getElementById("userOptions.apply.button").disabled = disable;
		}
		catch (err) {
			pm_Logger.logError(err);
		}
	},
	
	
	userOptionsCharacterChanged: function userOptionsCharacterChanged() {
		try {
			var charId = parseInt(document.getElementById("userOptions.character.list").value || 0);
	
			if (charId) {
				pm_Prefs.setPref(pm_PrefKeys.CURRENT_CHARACTER, charId);
				
				var portrait = pm_Prefs.getCharacterPref(charId, 
					pm_PrefKeys.CHARACTER_PORTRAIT, 
					pm_DefaultPrefs.CHARACTER_PORTRAIT);
	
				var languageId = pm_Prefs.getCharacterPref(charId, 
					pm_PrefKeys.LANGUAGE_ID, 
					pm_DefaultPrefs.LANGUAGE_ID);
	
				var dateFormat = pm_Prefs.getCharacterPref(charId, 
					pm_PrefKeys.DATE_FORMAT_TYPE_ID, 
					pm_DefaultPrefs.DATE_FORMAT_TYPE_ID);
	
				var timeFormat = pm_Prefs.getCharacterPref(charId, 
					pm_PrefKeys.TIME_FORMAT_TYPE_ID, 
					pm_DefaultPrefs.TIME_FORMAT_TYPE_ID);
				
				var cityName = pm_Prefs.getCharacterPref(charId, 
					pm_PrefKeys.CITY_NAME, 
					pm_DefaultPrefs.CITY_NAME);
				
				document.getElementById("userOptions.characterPortrait.image").src = portrait;
				document.getElementById("userOptions.language.list").value = languageId;
				document.getElementById("userOptions.dateFormat.radiogroup").value = dateFormat;
				document.getElementById("userOptions.timeFormat.radiogroup").value = timeFormat;
				document.getElementById("userOptions.city.textbox").value = cityName;
				this.userOptionsEnableAll(true);
			}
			else {
				document.getElementById("userOptions.characterPortrait.image").src = "";
				document.getElementById("userOptions.language.list").value = 0;
				document.getElementById("userOptions.dateFormat.radiogroup").value = 0;
				document.getElementById("userOptions.timeFormat.radiogroup").value = 0;
				document.getElementById("userOptions.city.textbox").value = "";
				this.userOptionsEnableAll(false);
			}
			
			this.userOptionsEnableApply(false);
		}
		catch (err) {
			pm_Logger.logError(err);
		}
		
		return true;
	}
};
